config: Give error message when not changing a multivar
[git/dscho.git] / t / test-lib.sh
blobb2ce2bc4b22f43c0b324ab3f596a7f865fa58cc1
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22 # do not redirect again
24 *' --tee '*|*' --va'*)
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset EMAIL
47 unset $(perl -e '
48 my @env = keys %ENV;
49 my $ok = join("|", qw(
50 TRACE
51 DEBUG
52 USE_LOOKUP
53 TEST
54 .*_TEST
55 PROVE
56 VALGRIND
57 ));
58 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
59 print join("\n", @vars);
61 GIT_AUTHOR_EMAIL=author@example.com
62 GIT_AUTHOR_NAME='A U Thor'
63 GIT_COMMITTER_EMAIL=committer@example.com
64 GIT_COMMITTER_NAME='C O Mitter'
65 GIT_MERGE_VERBOSITY=5
66 export GIT_MERGE_VERBOSITY
67 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
68 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
69 export EDITOR
71 # Protect ourselves from common misconfiguration to export
72 # CDPATH into the environment
73 unset CDPATH
75 unset GREP_OPTIONS
77 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
78 1|2|true)
79 echo "* warning: Some tests will not work if GIT_TRACE" \
80 "is set as to trace on STDERR ! *"
81 echo "* warning: Please set GIT_TRACE to something" \
82 "other than 1, 2 or true ! *"
84 esac
86 # Convenience
88 # A regexp to match 5 and 40 hexdigits
89 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
90 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
92 # Zero SHA-1
93 _z40=0000000000000000000000000000000000000000
95 # Each test should start with something like this, after copyright notices:
97 # test_description='Description of this test...
98 # This test checks if command xyzzy does the right thing...
99 # '
100 # . ./test-lib.sh
101 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
102 TERM=$ORIGINAL_TERM &&
103 export TERM &&
104 [ -t 1 ] &&
105 tput bold >/dev/null 2>&1 &&
106 tput setaf 1 >/dev/null 2>&1 &&
107 tput sgr0 >/dev/null 2>&1
108 ) &&
109 color=t
111 while test "$#" -ne 0
113 case "$1" in
114 -d|--d|--de|--deb|--debu|--debug)
115 debug=t; shift ;;
116 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
117 immediate=t; shift ;;
118 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
119 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
120 -h|--h|--he|--hel|--help)
121 help=t; shift ;;
122 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
123 verbose=t; shift ;;
124 -q|--q|--qu|--qui|--quie|--quiet)
125 # Ignore --quiet under a TAP::Harness. Saying how many tests
126 # passed without the ok/not ok details is always an error.
127 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
128 --with-dashes)
129 with_dashes=t; shift ;;
130 --no-color)
131 color=; shift ;;
132 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
133 valgrind=t; verbose=t; shift ;;
134 --tee)
135 shift ;; # was handled already
136 --root=*)
137 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
138 shift ;;
140 echo "error: unknown test option '$1'" >&2; exit 1 ;;
141 esac
142 done
144 if test -n "$color"; then
145 say_color () {
147 TERM=$ORIGINAL_TERM
148 export TERM
149 case "$1" in
150 error) tput bold; tput setaf 1;; # bold red
151 skip) tput bold; tput setaf 2;; # bold green
152 pass) tput setaf 2;; # green
153 info) tput setaf 3;; # brown
154 *) test -n "$quiet" && return;;
155 esac
156 shift
157 printf "%s" "$*"
158 tput sgr0
159 echo
162 else
163 say_color() {
164 test -z "$1" && test -n "$quiet" && return
165 shift
166 echo "$*"
170 error () {
171 say_color error "error: $*"
172 GIT_EXIT_OK=t
173 exit 1
176 say () {
177 say_color info "$*"
180 test "${test_description}" != "" ||
181 error "Test script did not set test_description."
183 if test "$help" = "t"
184 then
185 echo "$test_description"
186 exit 0
189 exec 5>&1
190 if test "$verbose" = "t"
191 then
192 exec 4>&2 3>&1
193 else
194 exec 4>/dev/null 3>/dev/null
197 test_failure=0
198 test_count=0
199 test_fixed=0
200 test_broken=0
201 test_success=0
203 test_external_has_tap=0
205 die () {
206 code=$?
207 if test -n "$GIT_EXIT_OK"
208 then
209 exit $code
210 else
211 echo >&5 "FATAL: Unexpected exit with code $code"
212 exit 1
216 GIT_EXIT_OK=
217 trap 'die' EXIT
219 # The semantics of the editor variables are that of invoking
220 # sh -c "$EDITOR \"$@\"" files ...
222 # If our trash directory contains shell metacharacters, they will be
223 # interpreted if we just set $EDITOR directly, so do a little dance with
224 # environment variables to work around this.
226 # In particular, quoting isn't enough, as the path may contain the same quote
227 # that we're using.
228 test_set_editor () {
229 FAKE_EDITOR="$1"
230 export FAKE_EDITOR
231 EDITOR='"$FAKE_EDITOR"'
232 export EDITOR
235 test_decode_color () {
236 awk '
237 function name(n) {
238 if (n == 0) return "RESET";
239 if (n == 1) return "BOLD";
240 if (n == 30) return "BLACK";
241 if (n == 31) return "RED";
242 if (n == 32) return "GREEN";
243 if (n == 33) return "YELLOW";
244 if (n == 34) return "BLUE";
245 if (n == 35) return "MAGENTA";
246 if (n == 36) return "CYAN";
247 if (n == 37) return "WHITE";
248 if (n == 40) return "BLACK";
249 if (n == 41) return "BRED";
250 if (n == 42) return "BGREEN";
251 if (n == 43) return "BYELLOW";
252 if (n == 44) return "BBLUE";
253 if (n == 45) return "BMAGENTA";
254 if (n == 46) return "BCYAN";
255 if (n == 47) return "BWHITE";
258 while (match($0, /\033\[[0-9;]*m/) != 0) {
259 printf "%s<", substr($0, 1, RSTART-1);
260 codes = substr($0, RSTART+2, RLENGTH-3);
261 if (length(codes) == 0)
262 printf "%s", name(0)
263 else {
264 n = split(codes, ary, ";");
265 sep = "";
266 for (i = 1; i <= n; i++) {
267 printf "%s%s", sep, name(ary[i]);
268 sep = ";"
271 printf ">";
272 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
274 print
279 nul_to_q () {
280 perl -pe 'y/\000/Q/'
283 q_to_nul () {
284 perl -pe 'y/Q/\000/'
287 q_to_cr () {
288 tr Q '\015'
291 q_to_tab () {
292 tr Q '\011'
295 append_cr () {
296 sed -e 's/$/Q/' | tr Q '\015'
299 remove_cr () {
300 tr '\015' Q | sed -e 's/Q$//'
303 # In some bourne shell implementations, the "unset" builtin returns
304 # nonzero status when a variable to be unset was not set in the first
305 # place.
307 # Use sane_unset when that should not be considered an error.
309 sane_unset () {
310 unset "$@"
311 return 0
314 test_tick () {
315 if test -z "${test_tick+set}"
316 then
317 test_tick=1112911993
318 else
319 test_tick=$(($test_tick + 60))
321 GIT_COMMITTER_DATE="$test_tick -0700"
322 GIT_AUTHOR_DATE="$test_tick -0700"
323 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
326 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
328 # This will commit a file with the given contents and the given commit
329 # message. It will also add a tag with <message> as name.
331 # Both <file> and <contents> default to <message>.
333 test_commit () {
334 file=${2:-"$1.t"}
335 echo "${3-$1}" > "$file" &&
336 git add "$file" &&
337 test_tick &&
338 git commit -m "$1" &&
339 git tag "$1"
342 # Call test_merge with the arguments "<message> <commit>", where <commit>
343 # can be a tag pointing to the commit-to-merge.
345 test_merge () {
346 test_tick &&
347 git merge -m "$1" "$2" &&
348 git tag "$1"
351 # This function helps systems where core.filemode=false is set.
352 # Use it instead of plain 'chmod +x' to set or unset the executable bit
353 # of a file in the working directory and add it to the index.
355 test_chmod () {
356 chmod "$@" &&
357 git update-index --add "--chmod=$@"
360 # Use test_set_prereq to tell that a particular prerequisite is available.
361 # The prerequisite can later be checked for in two ways:
363 # - Explicitly using test_have_prereq.
365 # - Implicitly by specifying the prerequisite tag in the calls to
366 # test_expect_{success,failure,code}.
368 # The single parameter is the prerequisite tag (a simple word, in all
369 # capital letters by convention).
371 test_set_prereq () {
372 satisfied="$satisfied$1 "
374 satisfied=" "
376 test_have_prereq () {
377 # prerequisites can be concatenated with ','
378 save_IFS=$IFS
379 IFS=,
380 set -- $*
381 IFS=$save_IFS
383 total_prereq=0
384 ok_prereq=0
385 missing_prereq=
387 for prerequisite
389 total_prereq=$(($total_prereq + 1))
390 case $satisfied in
391 *" $prerequisite "*)
392 ok_prereq=$(($ok_prereq + 1))
395 # Keep a list of missing prerequisites
396 if test -z "$missing_prereq"
397 then
398 missing_prereq=$prerequisite
399 else
400 missing_prereq="$prerequisite,$missing_prereq"
402 esac
403 done
405 test $total_prereq = $ok_prereq
408 test_declared_prereq () {
409 case ",$test_prereq," in
410 *,$1,*)
411 return 0
413 esac
414 return 1
417 # You are not expected to call test_ok_ and test_failure_ directly, use
418 # the text_expect_* functions instead.
420 test_ok_ () {
421 test_success=$(($test_success + 1))
422 say_color "" "ok $test_count - $@"
425 test_failure_ () {
426 test_failure=$(($test_failure + 1))
427 say_color error "not ok - $test_count $1"
428 shift
429 echo "$@" | sed -e 's/^/# /'
430 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
433 test_known_broken_ok_ () {
434 test_fixed=$(($test_fixed+1))
435 say_color "" "ok $test_count - $@ # TODO known breakage"
438 test_known_broken_failure_ () {
439 test_broken=$(($test_broken+1))
440 say_color skip "not ok $test_count - $@ # TODO known breakage"
443 test_debug () {
444 test "$debug" = "" || eval "$1"
447 test_run_ () {
448 test_cleanup=:
449 eval >&3 2>&4 "$1"
450 eval_ret=$?
451 eval >&3 2>&4 "$test_cleanup"
452 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
453 echo ""
455 return 0
458 test_skip () {
459 test_count=$(($test_count+1))
460 to_skip=
461 for skp in $GIT_SKIP_TESTS
463 case $this_test.$test_count in
464 $skp)
465 to_skip=t
466 break
467 esac
468 done
469 if test -z "$to_skip" && test -n "$test_prereq" &&
470 ! test_have_prereq "$test_prereq"
471 then
472 to_skip=t
474 case "$to_skip" in
476 of_prereq=
477 if test "$missing_prereq" != "$test_prereq"
478 then
479 of_prereq=" of $test_prereq"
482 say_color skip >&3 "skipping test: $@"
483 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
484 : true
487 false
489 esac
492 test_expect_failure () {
493 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
494 test "$#" = 2 ||
495 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
496 export test_prereq
497 if ! test_skip "$@"
498 then
499 say >&3 "checking known breakage: $2"
500 test_run_ "$2"
501 if [ "$?" = 0 -a "$eval_ret" = 0 ]
502 then
503 test_known_broken_ok_ "$1"
504 else
505 test_known_broken_failure_ "$1"
508 echo >&3 ""
511 test_expect_success () {
512 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
513 test "$#" = 2 ||
514 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
515 export test_prereq
516 if ! test_skip "$@"
517 then
518 say >&3 "expecting success: $2"
519 test_run_ "$2"
520 if [ "$?" = 0 -a "$eval_ret" = 0 ]
521 then
522 test_ok_ "$1"
523 else
524 test_failure_ "$@"
527 echo >&3 ""
530 # test_external runs external test scripts that provide continuous
531 # test output about their progress, and succeeds/fails on
532 # zero/non-zero exit code. It outputs the test output on stdout even
533 # in non-verbose mode, and announces the external script with "# run
534 # <n>: ..." before running it. When providing relative paths, keep in
535 # mind that all scripts run in "trash directory".
536 # Usage: test_external description command arguments...
537 # Example: test_external 'Perl API' perl ../path/to/test.pl
538 test_external () {
539 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
540 test "$#" = 3 ||
541 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
542 descr="$1"
543 shift
544 export test_prereq
545 if ! test_skip "$descr" "$@"
546 then
547 # Announce the script to reduce confusion about the
548 # test output that follows.
549 say_color "" "# run $test_count: $descr ($*)"
550 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
551 # to be able to use them in script
552 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
553 # Run command; redirect its stderr to &4 as in
554 # test_run_, but keep its stdout on our stdout even in
555 # non-verbose mode.
556 "$@" 2>&4
557 if [ "$?" = 0 ]
558 then
559 if test $test_external_has_tap -eq 0; then
560 test_ok_ "$descr"
561 else
562 say_color "" "# test_external test $descr was ok"
563 test_success=$(($test_success + 1))
565 else
566 if test $test_external_has_tap -eq 0; then
567 test_failure_ "$descr" "$@"
568 else
569 say_color error "# test_external test $descr failed: $@"
570 test_failure=$(($test_failure + 1))
576 # Like test_external, but in addition tests that the command generated
577 # no output on stderr.
578 test_external_without_stderr () {
579 # The temporary file has no (and must have no) security
580 # implications.
581 tmp=${TMPDIR:-/tmp}
582 stderr="$tmp/git-external-stderr.$$.tmp"
583 test_external "$@" 4> "$stderr"
584 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
585 descr="no stderr: $1"
586 shift
587 say >&3 "# expecting no stderr from previous command"
588 if [ ! -s "$stderr" ]; then
589 rm "$stderr"
591 if test $test_external_has_tap -eq 0; then
592 test_ok_ "$descr"
593 else
594 say_color "" "# test_external_without_stderr test $descr was ok"
595 test_success=$(($test_success + 1))
597 else
598 if [ "$verbose" = t ]; then
599 output=`echo; echo "# Stderr is:"; cat "$stderr"`
600 else
601 output=
603 # rm first in case test_failure exits.
604 rm "$stderr"
605 if test $test_external_has_tap -eq 0; then
606 test_failure_ "$descr" "$@" "$output"
607 else
608 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
609 test_failure=$(($test_failure + 1))
614 # debugging-friendly alternatives to "test [-f|-d|-e]"
615 # The commands test the existence or non-existence of $1. $2 can be
616 # given to provide a more precise diagnosis.
617 test_path_is_file () {
618 if ! [ -f "$1" ]
619 then
620 echo "File $1 doesn't exist. $*"
621 false
625 test_path_is_dir () {
626 if ! [ -d "$1" ]
627 then
628 echo "Directory $1 doesn't exist. $*"
629 false
633 test_path_is_missing () {
634 if [ -e "$1" ]
635 then
636 echo "Path exists:"
637 ls -ld "$1"
638 if [ $# -ge 1 ]; then
639 echo "$*"
641 false
645 # test_line_count checks that a file has the number of lines it
646 # ought to. For example:
648 # test_expect_success 'produce exactly one line of output' '
649 # do something >output &&
650 # test_line_count = 1 output
653 # is like "test $(wc -l <output) = 1" except that it passes the
654 # output through when the number of lines is wrong.
656 test_line_count () {
657 if test $# != 3
658 then
659 error "bug in the test script: not 3 parameters to test_line_count"
660 elif ! test $(wc -l <"$3") "$1" "$2"
661 then
662 echo "test_line_count: line count for $3 !$1 $2"
663 cat "$3"
664 return 1
668 # This is not among top-level (test_expect_success | test_expect_failure)
669 # but is a prefix that can be used in the test script, like:
671 # test_expect_success 'complain and die' '
672 # do something &&
673 # do something else &&
674 # test_must_fail git checkout ../outerspace
677 # Writing this as "! git checkout ../outerspace" is wrong, because
678 # the failure could be due to a segv. We want a controlled failure.
680 test_must_fail () {
681 "$@"
682 exit_code=$?
683 if test $exit_code = 0; then
684 echo >&2 "test_must_fail: command succeeded: $*"
685 return 1
686 elif test $exit_code -gt 129 -a $exit_code -le 192; then
687 echo >&2 "test_must_fail: died by signal: $*"
688 return 1
689 elif test $exit_code = 127; then
690 echo >&2 "test_must_fail: command not found: $*"
691 return 1
693 return 0
696 # Similar to test_must_fail, but tolerates success, too. This is
697 # meant to be used in contexts like:
699 # test_expect_success 'some command works without configuration' '
700 # test_might_fail git config --unset all.configuration &&
701 # do something
704 # Writing "git config --unset all.configuration || :" would be wrong,
705 # because we want to notice if it fails due to segv.
707 test_might_fail () {
708 "$@"
709 exit_code=$?
710 if test $exit_code -gt 129 -a $exit_code -le 192; then
711 echo >&2 "test_might_fail: died by signal: $*"
712 return 1
713 elif test $exit_code = 127; then
714 echo >&2 "test_might_fail: command not found: $*"
715 return 1
717 return 0
720 # Similar to test_must_fail and test_might_fail, but check that a
721 # given command exited with a given exit code. Meant to be used as:
723 # test_expect_success 'Merge with d/f conflicts' '
724 # test_expect_code 1 git merge "merge msg" B master
727 test_expect_code () {
728 want_code=$1
729 shift
730 "$@"
731 exit_code=$?
732 if test $exit_code = $want_code
733 then
734 echo >&2 "test_expect_code: command exited with $exit_code: $*"
735 return 0
736 else
737 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
738 return 1
742 # test_cmp is a helper function to compare actual and expected output.
743 # You can use it like:
745 # test_expect_success 'foo works' '
746 # echo expected >expected &&
747 # foo >actual &&
748 # test_cmp expected actual
751 # This could be written as either "cmp" or "diff -u", but:
752 # - cmp's output is not nearly as easy to read as diff -u
753 # - not all diff versions understand "-u"
755 test_cmp() {
756 $GIT_TEST_CMP "$@"
759 # This function can be used to schedule some commands to be run
760 # unconditionally at the end of the test to restore sanity:
762 # test_expect_success 'test core.capslock' '
763 # git config core.capslock true &&
764 # test_when_finished "git config --unset core.capslock" &&
765 # hello world
768 # That would be roughly equivalent to
770 # test_expect_success 'test core.capslock' '
771 # git config core.capslock true &&
772 # hello world
773 # git config --unset core.capslock
776 # except that the greeting and config --unset must both succeed for
777 # the test to pass.
779 test_when_finished () {
780 test_cleanup="{ $*
781 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
784 # Most tests can use the created repository, but some may need to create more.
785 # Usage: test_create_repo <directory>
786 test_create_repo () {
787 test "$#" = 1 ||
788 error "bug in the test script: not 1 parameter to test-create-repo"
789 repo="$1"
790 mkdir -p "$repo"
792 cd "$repo" || error "Cannot setup test environment"
793 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
794 error "cannot run git init -- have you built things yet?"
795 mv .git/hooks .git/hooks-disabled
796 ) || exit
799 test_done () {
800 GIT_EXIT_OK=t
802 if test -z "$HARNESS_ACTIVE"; then
803 test_results_dir="$TEST_DIRECTORY/test-results"
804 mkdir -p "$test_results_dir"
805 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
807 cat >>"$test_results_path" <<-EOF
808 total $test_count
809 success $test_success
810 fixed $test_fixed
811 broken $test_broken
812 failed $test_failure
817 if test "$test_fixed" != 0
818 then
819 say_color pass "# fixed $test_fixed known breakage(s)"
821 if test "$test_broken" != 0
822 then
823 say_color error "# still have $test_broken known breakage(s)"
824 msg="remaining $(($test_count-$test_broken)) test(s)"
825 else
826 msg="$test_count test(s)"
828 case "$test_failure" in
830 # Maybe print SKIP message
831 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
833 if test $test_external_has_tap -eq 0; then
834 say_color pass "# passed all $msg"
835 say "1..$test_count$skip_all"
838 test -d "$remove_trash" &&
839 cd "$(dirname "$remove_trash")" &&
840 rm -rf "$(basename "$remove_trash")"
842 exit 0 ;;
845 if test $test_external_has_tap -eq 0; then
846 say_color error "# failed $test_failure among $msg"
847 say "1..$test_count"
850 exit 1 ;;
852 esac
855 # Test the binaries we have just built. The tests are kept in
856 # t/ subdirectory and are run in 'trash directory' subdirectory.
857 if test -z "$TEST_DIRECTORY"
858 then
859 # We allow tests to override this, in case they want to run tests
860 # outside of t/, e.g. for running tests on the test library
861 # itself.
862 TEST_DIRECTORY=$(pwd)
864 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
866 if test -n "$valgrind"
867 then
868 make_symlink () {
869 test -h "$2" &&
870 test "$1" = "$(readlink "$2")" || {
871 # be super paranoid
872 if mkdir "$2".lock
873 then
874 rm -f "$2" &&
875 ln -s "$1" "$2" &&
876 rm -r "$2".lock
877 else
878 while test -d "$2".lock
880 say "Waiting for lock on $2."
881 sleep 1
882 done
887 make_valgrind_symlink () {
888 # handle only executables
889 test -x "$1" || return
891 base=$(basename "$1")
892 symlink_target=$GIT_BUILD_DIR/$base
893 # do not override scripts
894 if test -x "$symlink_target" &&
895 test ! -d "$symlink_target" &&
896 test "#!" != "$(head -c 2 < "$symlink_target")"
897 then
898 symlink_target=../valgrind.sh
900 case "$base" in
901 *.sh|*.perl)
902 symlink_target=../unprocessed-script
903 esac
904 # create the link, or replace it if it is out of date
905 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
908 # override all git executables in TEST_DIRECTORY/..
909 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
910 mkdir -p "$GIT_VALGRIND"/bin
911 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
913 make_valgrind_symlink $file
914 done
915 OLDIFS=$IFS
916 IFS=:
917 for path in $PATH
919 ls "$path"/git-* 2> /dev/null |
920 while read file
922 make_valgrind_symlink "$file"
923 done
924 done
925 IFS=$OLDIFS
926 PATH=$GIT_VALGRIND/bin:$PATH
927 GIT_EXEC_PATH=$GIT_VALGRIND/bin
928 export GIT_VALGRIND
929 elif test -n "$GIT_TEST_INSTALLED" ; then
930 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
931 error "Cannot run git from $GIT_TEST_INSTALLED."
932 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
933 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
934 else # normal case, use ../bin-wrappers only unless $with_dashes:
935 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
936 if ! test -x "$git_bin_dir/git" ; then
937 if test -z "$with_dashes" ; then
938 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
940 with_dashes=t
942 PATH="$git_bin_dir:$PATH"
943 GIT_EXEC_PATH=$GIT_BUILD_DIR
944 if test -n "$with_dashes" ; then
945 PATH="$GIT_BUILD_DIR:$PATH"
948 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
949 unset GIT_CONFIG
950 GIT_CONFIG_NOSYSTEM=1
951 GIT_ATTR_NOSYSTEM=1
952 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
954 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
956 if test -z "$GIT_TEST_CMP"
957 then
958 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
959 then
960 GIT_TEST_CMP="$DIFF -c"
961 else
962 GIT_TEST_CMP="$DIFF -u"
966 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
967 export GITPERLLIB
968 test -d "$GIT_BUILD_DIR"/templates/blt || {
969 error "You haven't built things yet, have you?"
972 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
973 then
974 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
975 export GITPYTHONLIB
976 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
977 error "You haven't built git_remote_helpers yet, have you?"
981 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
982 echo >&2 'You need to build test-chmtime:'
983 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
984 exit 1
987 # Test repository
988 test="trash directory.$(basename "$0" .sh)"
989 test -n "$root" && test="$root/$test"
990 case "$test" in
991 /*) TRASH_DIRECTORY="$test" ;;
992 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
993 esac
994 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
995 rm -fr "$test" || {
996 GIT_EXIT_OK=t
997 echo >&5 "FATAL: Cannot prepare test area"
998 exit 1
1001 HOME="$TRASH_DIRECTORY"
1002 export HOME
1004 test_create_repo "$test"
1005 # Use -P to resolve symlinks in our working directory so that the cwd
1006 # in subprocesses like git equals our $PWD (for pathname comparisons).
1007 cd -P "$test" || exit 1
1009 this_test=${0##*/}
1010 this_test=${this_test%%-*}
1011 for skp in $GIT_SKIP_TESTS
1013 case "$this_test" in
1014 $skp)
1015 say_color skip >&3 "skipping test $this_test altogether"
1016 skip_all="skip all tests in $this_test"
1017 test_done
1018 esac
1019 done
1021 # Provide an implementation of the 'yes' utility
1022 yes () {
1023 if test $# = 0
1024 then
1026 else
1027 y="$*"
1030 while echo "$y"
1033 done
1036 # Fix some commands on Windows
1037 case $(uname -s) in
1038 *MINGW*)
1039 # Windows has its own (incompatible) sort and find
1040 sort () {
1041 /usr/bin/sort "$@"
1043 find () {
1044 /usr/bin/find "$@"
1046 sum () {
1047 md5sum "$@"
1049 # git sees Windows-style pwd
1050 pwd () {
1051 builtin pwd -W
1053 # no POSIX permissions
1054 # backslashes in pathspec are converted to '/'
1055 # exec does not inherit the PID
1056 test_set_prereq MINGW
1057 test_set_prereq SED_STRIPS_CR
1059 *CYGWIN*)
1060 test_set_prereq POSIXPERM
1061 test_set_prereq EXECKEEPSPID
1062 test_set_prereq NOT_MINGW
1063 test_set_prereq SED_STRIPS_CR
1066 test_set_prereq POSIXPERM
1067 test_set_prereq BSLASHPSPEC
1068 test_set_prereq EXECKEEPSPID
1069 test_set_prereq NOT_MINGW
1071 esac
1073 test -z "$NO_PERL" && test_set_prereq PERL
1074 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1076 # Can we rely on git's output in the C locale?
1077 if test -n "$GETTEXT_POISON"
1078 then
1079 GIT_GETTEXT_POISON=YesPlease
1080 export GIT_GETTEXT_POISON
1081 else
1082 test_set_prereq C_LOCALE_OUTPUT
1085 # Use this instead of test_cmp to compare files that contain expected and
1086 # actual output from git commands that can be translated. When running
1087 # under GETTEXT_POISON this pretends that the command produced expected
1088 # results.
1089 test_i18ncmp () {
1090 test -n "$GETTEXT_POISON" || test_cmp "$@"
1093 # Use this instead of "grep expected-string actual" to see if the
1094 # output from a git command that can be translated either contains an
1095 # expected string, or does not contain an unwanted one. When running
1096 # under GETTEXT_POISON this pretends that the command produced expected
1097 # results.
1098 test_i18ngrep () {
1099 if test -n "$GETTEXT_POISON"
1100 then
1101 : # pretend success
1102 elif test "x!" = "x$1"
1103 then
1104 shift
1105 ! grep "$@"
1106 else
1107 grep "$@"
1111 # test whether the filesystem supports symbolic links
1112 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1113 rm -f y
1115 # When the tests are run as root, permission tests will report that
1116 # things are writable when they shouldn't be.
1117 test -w / || test_set_prereq SANITY